% this function genereate the sampling matrix by randomly setting some
% sampling position to be zero
function omega=GenerateSample(row, col, ratio)
if ratio==1
    omega=ones(row, col);
else
    alpha=0.5*(1-ratio);
    global SampleSeed;
    if isempty(SampleSeed)
        SampleSeed=RandStream('mrg32k3a');
    end
    while 1
        omega=ones(row, col);
        for i=1: row
            idx=randperm(SampleSeed, col);
            omega(i, idx(1: floor(col*ratio+rand(1))))=0;
        end
        if min(sum(omega, 1))/row>=alpha && min(sum(omega, 2))/col>=alpha 
            break;
        end
    end
    disp('random sample generated');
end
end

% this function genereate the sampling matrix by rand. Since it generates
% inaccurate sampling ratio, it is rejected now
function omega=GenerateSample1(row, col, ratio)
global SampleSeed;
if isempty(SampleSeed)
    SampleSeed=RandStream('mrg32k3a');
end
omega=rand(SampleSeed, row, col);
omega(omega<ratio)=0;
omega(omega>=ratio)=1;
end