% this scripts will generate the result
%% ========================================================================
% define the parameters
train_result='AR-result.mat';
test_result='AR-10-07-19-21-39-20-result.mat';
%% ========================================================================
% for the training data
load(train_result);
idx_train=idx;
lbl=ceil([1: 1300]/13);
idx1_train=zeros(1, 1300);
idx2_train=zeros(1, 1300);
coef_train=zeros(126, 1300);
coef1_train=zeros(100, 1300);
coef2_train=zeros(100, 1300);
for i=1: 1300
    idx1_train(i)=output(i).idx1;
    idx2_train(i)=output(i).idx2;
    coef_train(:, i)=output(i).coef(1: 126);
    coef1_train(:, i)=output(i).err1';
    coef2_train(:, i)=output(i).err2';
end
err_train=find(idx_train~=lbl);
err1_train=find(idx1_train~=lbl);
err2_train=find(idx2_train~=lbl);
clear i output idx;
%% ========================================================================
% for the testing result
load(test_result);
idx_test=idx;
idx1_test=zeros(1, 1300);
idx2_test=zeros(1, 1300);
coef_test=zeros(126, 1300);
coef1_test=zeros(100, 1300);
coef2_test=zeros(100, 1300);
for i=1: 1300
    idx1_test(i)=output(i).idx1;
    idx2_test(i)=output(i).idx2;
    coef_test(:, i)=output(i).coef(1: 126);
    coef1_test(:, i)=output(i).err1';
    coef2_test(:, i)=output(i).err2';
end
err_test=find(idx_test~=lbl);
err1_test=find(idx1_test~=lbl);
err2_test=find(idx2_test~=lbl);
clear i output idx;
%% ========================================================================
% generate confusion map
conf_train=zeros(100, 100);
conf1_train=zeros(100, 100);
conf2_train=zeros(100, 100);
conf_test=zeros(100, 100);
conf1_test=zeros(100, 100);
conf2_test=zeros(100, 100);
for i=1: 100
    for j=1: 13
        idx=i*13+j-13;
        conf_train(i, idx_train(idx))=conf_train(i, idx_train(idx))+1;
        conf1_train(i, idx1_train(idx))=conf1_train(i, idx1_train(idx))+1;
        conf2_train(i, idx2_train(idx))=conf2_train(i, idx2_train(idx))+1;
        conf_test(i, idx_test(idx))=conf_test(i, idx_test(idx))+1;
        conf1_test(i, idx1_test(idx))=conf1_test(i, idx1_test(idx))+1;
        conf2_test(i, idx2_test(idx))=conf2_test(i, idx2_test(idx))+1;
    end
end
clear i j;
h=figure;
subplot(231); imagesc(conf_train); axis image; colormap gray; title(sprintf('Train by SCI: %d\n', length(err_train)));
subplot(232); imagesc(conf1_train); axis image; colormap gray; title(sprintf('Train by error: %d\n', length(err1_train)));
subplot(233); imagesc(conf2_train); axis image; colormap gray; title(sprintf('Train by error*: %d\n', length(err2_train)));
subplot(234); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by SCI: %d\n', length(err_test)));
subplot(235); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by error: %d\n', length(err1_test)));
subplot(236); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by error*: %d\n', length(err2_test)));
saveas(h, 'confmtx.tif');
%% ========================================================================
% generate the error distribution
err_cond=zeros(6, 5);
tmp=mod(err_train, 13);
tmp(tmp==0)=13;
err_cond(1, 1)=length(find(tmp<=4));
err_cond(1, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(1, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(1, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(1, 5)=length(tmp);
tmp=mod(err1_train, 13);
tmp(tmp==0)=13;
err_cond(2, 1)=length(find(tmp<=4));
err_cond(2, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(2, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(2, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(2, 5)=length(tmp);
tmp=mod(err2_train, 13);
tmp(tmp==0)=13;
err_cond(3, 1)=length(find(tmp<=4));
err_cond(3, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(3, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(3, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(3, 5)=length(tmp);
tmp=mod(err_test, 13);
tmp(tmp==0)=13;
err_cond(4, 1)=length(find(tmp<=4));
err_cond(4, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(4, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(4, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(4, 5)=length(tmp);
tmp=mod(err1_test, 13);
tmp(tmp==0)=13;
err_cond(5, 1)=length(find(tmp<=4));
err_cond(5, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(5, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(5, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(5, 5)=length(tmp);
tmp=mod(err2_test, 13);
tmp(tmp==0)=13;
err_cond(6, 1)=length(find(tmp<=4));
err_cond(6, 2)=length(find(tmp>=5 & tmp<=7));
err_cond(6, 3)=length(find(tmp>=8 & tmp<=10));
err_cond(6, 4)=length(find(tmp>=11 & tmp<=13));
err_cond(6, 5)=length(tmp);
clear tmp;
%% ========================================================================
% save the result
common=zeros(55*10, 40*10);
for i=1: 10
    for j=1: 10
        common(i*55-54: i*55, j*40-39: j*40)=C_hat(:, (10*i+j-11)*40+1: (10*i+j-10)*40);
    end
end
common=matrix2im(common, 'common.tif', 8);
condition=zeros(55*2, 40*13);
for i=1: 2
    for j=1: 13
        condition(i*55-54: i*55, j*40-39: j*40)=A_hat(:, (13*i+j-14)*40+1: (13*i+j-13)*40);
    end
end
condition=matrix2im(condition, 'condition.tif', 8);
X=[output(1).X; output(2).X];
matrix2im([X(1: 1375, :) X(1376: 2750, :) X(2751: 4125, :) X(4126: 5500, :)], 'X.tif', 8);
matrix2im([E_hat(1: 1375, :) E_hat(1376: 2750, :) E_hat(2751: 4125, :) E_hat(4126: 5500, :)], 'E_hat.tif', 8);
clear i j common condition;
save(train_result);
X=zeros(55*26, 40*100);
%% ========================================================================
% reconstruct the image
for i=1: 26
    for j=1: 100
        X((i-1)*55+1: i*55, (j-1)*40+1: j*40)=A_hat(:, (i-1)*40+1: i*40)+C_hat(:, (j-1)*40+1: j*40);
    end
end
clear i j;
img=matrix2im(X, 'AR_E+C_1.25.tif', 8);
i=1; j=1;
subplot(231); hist(reshape(C_hat(:, (i-1)*40+1: i*40), 1, []), 100); title('Common');
subplot(232); hist(reshape(A_hat(:, (j-1)*40+1: j*40), 1, []), 100); title('Low rank');
if i<=50
    subplot(233); hist(reshape(E_hat((i-1)*55+1: i*55, (j-1)*40+1: j*40), 1, []), 100); title('Sparse');
else
    subplot(233); hist(reshape(E_hat((i-51)*55+1: (i-50)*55, (j-1)*40+1: j*40), 1, []), 100); title('Sparse');
end
subplot(234); imagesc(C_hat(:, (i-1)*40+1: i*40)); axis image; axis off; colormap gray; title('Common');
subplot(235); imagesc(A_hat(:, (j-1)*40+1: j*40)); axis image; axis off; colormap gray; title('Low rank');
if i<=50
    subplot(236); imagesc(abs(E_hat((i-1)*55+1: i*55, (j-1)*40+1: j*40))); axis image; axis off; colormap gray; title('Sparse');
else
    subplot(236); imagesc(abs(E_hat((i-51)*55+1: (i-50)*55, (j-1)*40+1: j*40))); axis image; axis off; colormap gray; title('Sparse');
end
%% Coding and decoding the innovation part

% Coding part
Gi=zeros(size(C_hat));
Gj=zeros(size(A_hat));
for i=1: 50
    for j=1: 13
        Gi(:, (i-1)*40+1: 40*i)=reshape(mean(reshape(E_hat(55*(i-1)+1: 55*i, 1: 520), 55*40, []), 2), 55, 40);
        Gj(:, (j-1)*40+1: 40*j)=reshape(mean(reshape(E_hat(1: 2750, 40*(j-1)+1: 40*j)', 55*40, []), 2), 40, 55)';
    end
end
for i=51: 100
    for j=14: 26
        Gi(:, (i-1)*40+1: 40*i)=reshape(mean(reshape(E_hat(55*(i-1)+1: 55*i, 1: 520), 55*40, []), 2), 55, 40);
        Gj(:, (j-1)*40+1: 40*j)=reshape(mean(reshape(E_hat(2751: 5500, 40*(j-14)+1: 40*(j-13))', 55*40, []), 2), 40, 55)';
    end
end
clear i j;
tmp=Gi;
Gi=zeros(55*10, 40*10);
for i=1: 10
    for j=1: 10
        Gi((i-1)*55+1: i*55, (j-1)*40+1: j*40)=tmp(:, 40*(10*i+j-11)+1: 40*(10*i+j-10));
    end
end
tmp=Gj;
Gj=zeros(55*6, 40*5);
l=1;
for i=1: 6
    for j=1: 5
        Gj((i-1)*55+1: i*55, (j-1)*40+1: j*40)=tmp(:, 40*(l-1)+1: 40*l);
        l=l+1;
        if l>26
            break;
        end
    end
end
clear i j l;
matrix2im(Gi, 'Gi.tif', 8);
matrix2im(Gj, 'Gj.tif', 8);

%Decoding part
E_tmp=zeros(size(E_hat));
for i=1: 50
    for j=1: 13
        E_tmp(55*(i-1)+1: 55*i, 40*(j-1)+1: 40*j)=ThreshJSM(Gi(:, (i-1)*40+1: 40*i), Gj(:, (j-1)*40+1: 40*j));
    end
end
for i=51: 100
    for j=14: 26
        E_tmp(55*(i-1)+1: 55*i, 40*(j-14)+1: 40*(j-13))=ThreshJSM(Gi(:, (i-1)*40+1: 40*i), Gj(:, (j-1)*40+1: 40*j));
    end
end
clear i j;
matrix2im([E_hat(1: 1375, :) E_hat(1376: 2750, :) E_hat(2751: 4125, :) E_hat(4126: end, :)], 'E_hat.tif', 8);
matrix2im([E_tmp(1: 2750, :) E_tmp(2751: end, :)], 'E_tmp.tif', 8);

X_hat=zeros(size(E_hat));
X_tmp=zeros(size(E_hat));
for i=1: 50
    for j=1: 13
        X_hat(55*(i-1)+1: 55*i, 40*(j-1)+1: 40*j)=E_hat(55*(i-1)+1: 55*i, 40*(j-1)+1: 40*j)+C_hat(:, (i-1)*40+1: 40*i)+A_hat(:, (j-1)*40+1: 40*j);
        X_tmp(55*(i-1)+1: 55*i, 40*(j-1)+1: 40*j)=E_tmp(55*(i-1)+1: 55*i, 40*(j-1)+1: 40*j)+C_hat(:, (i-1)*40+1: 40*i)+A_hat(:, (j-1)*40+1: 40*j);
    end
end
for i=51: 100
    for j=14: 26
        X_hat(55*(i-1)+1: 55*i, 40*(j-14)+1: 40*(j-13))=E_hat(55*(i-1)+1: 55*i, 40*(j-14)+1: 40*(j-13))+C_hat(:, (i-1)*40+1: 40*i)+A_hat(:, (j-1)*40+1: 40*j);
        X_tmp(55*(i-1)+1: 55*i, 40*(j-14)+1: 40*(j-13))=E_tmp(55*(i-1)+1: 55*i, 40*(j-14)+1: 40*(j-13))+C_hat(:, (i-1)*40+1: 40*i)+A_hat(:, (j-1)*40+1: 40*j);
    end
end
clear i j;
matrix2im([X_hat(1: 2750, :) X_hat(2751: end, :)], 'X_hat.tif', 8);
matrix2im([X_tmp(1: 2750, :) X_tmp(2751: end, :)], 'X_tmp.tif', 8);


lbl=1: 1300;
lbl=mod(lbl, 13);
lbl(lbl==0)=13;
idx(idx>13)=idx(idx>13)-13;
idx1(idx1>13)=idx1(idx1>13)-13;
err=find(idx~=lbl);
err1=find(idx1~=lbl);
conf=zeros(13, 13);
for i=1: 100
    for j=1: 13
        idx2=i*13+j-13;
        conf(j, idx1(idx2))=conf(j, idx1(idx2))+1;
    end
end

idx1=zeros(1, 1300);
for i=1: 1300
    idx1(i)=output(i).idx;
end
lbl=1: 1300;
lbl=mod(lbl, 13);
lbl(lbl==0)=13;
lbl(651: end)=lbl(651: end)+13;
err=find(idx~=lbl);
err1=find(idx1~=lbl);
conf=zeros(26, 26);
for i=1: 100
    for j=1: 13
        idx2=i*13+j-13;
        conf(j, idx1(idx2))=conf(j, idx1(idx2))+1;
    end
end