% this scripts will generate the result
clear all;
close all;
%% ========================================================================
% define the parameters
train_result='YaleB-result.mat';
test_result='YaleB-10-07-14-23-37-19-result.mat';
n_people=38;
n_train=32;
n_test=32;
height=48;
width=42;
row=7;
column=10;
%% ========================================================================
% for the training data
load(train_result);
idx_train=idx;
lbl=ceil([1: n_people*n_train]/n_train);
idx1_train=zeros(1, n_people*n_train);
idx2_train=zeros(1, n_people*n_train);
coef_train=zeros(n_people+n_train, n_people*n_train);
coef1_train=zeros(n_people, n_people*n_train);
coef2_train=zeros(n_people, n_people*n_train);
for i=1: n_people*n_train
    idx1_train(i)=output(i).idx1;
    idx2_train(i)=output(i).idx2;
    coef_train(:, i)=output(i).coef(1: n_people+n_train);
    coef1_train(:, i)=output(i).err1';
    coef2_train(:, i)=output(i).err2';
end
err_train=find(idx_train~=lbl);
err1_train=find(idx1_train~=lbl);
err2_train=find(idx2_train~=lbl);
clear i output idx;
%% ========================================================================
% for the testing result
load(test_result, 'idx', 'output');
lbl=ceil([1: n_people*n_test]/n_test);
idx_test=idx;
idx1_test=zeros(1, n_people*n_test);
idx2_test=zeros(1, n_people*n_test);
coef_test=zeros(n_people+n_train, n_people*n_test);
coef1_test=zeros(n_people, n_people*n_test);
coef2_test=zeros(n_people, n_people*n_test);
for i=1: n_people*n_test
    idx1_test(i)=output(i).idx1;
    idx2_test(i)=output(i).idx2;
    coef_test(:, i)=output(i).coef(1: n_people+n_train);
    coef1_test(:, i)=output(i).err1';
    coef2_test(:, i)=output(i).err2';
end
err_test=find(idx_test~=lbl);
err1_test=find(idx1_test~=lbl);
err2_test=find(idx2_test~=lbl);
clear i output idx;
%% ========================================================================
% generate confusion map
conf_train=zeros(n_people, n_people);
conf1_train=zeros(n_people, n_people);
conf2_train=zeros(n_people, n_people);
conf_test=zeros(n_people, n_people);
conf1_test=zeros(n_people, n_people);
conf2_test=zeros(n_people, n_people);
for i=1: n_people
    for j=1: n_test
        idx=i*n_test+j-n_test;
        conf_test(i, idx_test(idx))=conf_test(i, idx_test(idx))+1;
        conf1_test(i, idx1_test(idx))=conf1_test(i, idx1_test(idx))+1;
        conf2_test(i, idx2_test(idx))=conf2_test(i, idx2_test(idx))+1;
    end
end
for i=1: n_people
    for j=1: n_train
        idx=i*n_train+j-n_train;
        conf_train(i, idx_train(idx))=conf_train(i, idx_train(idx))+1;
        conf1_train(i, idx1_train(idx))=conf1_train(i, idx1_train(idx))+1;
        conf2_train(i, idx2_train(idx))=conf2_train(i, idx2_train(idx))+1;
    end
end
clear i j;
h=figure;
subplot(231); imagesc(conf_train); axis image; colormap gray; title(sprintf('Train by SCI: %d\n', length(err_train)));
subplot(232); imagesc(conf1_train); axis image; colormap gray; title(sprintf('Train by error: %d\n', length(err1_train)));
subplot(233); imagesc(conf2_train); axis image; colormap gray; title(sprintf('Train by error*: %d\n', length(err2_train)));
subplot(234); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by SCI: %d\n', length(err_test)));
subplot(235); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by error: %d\n', length(err1_test)));
subplot(236); imagesc(conf_test); axis image; colormap gray; title(sprintf('Test by error*: %d\n', length(err2_test)));
saveas(h, 'confmtx.tif');
%% ========================================================================
% save the result
%% ========================================================================
% save the result
common=zeros(48*2, 42*19);
for i=1: 2
    for j=1: 19
        common(i*48-47: i*48, j*42-41: j*42)=reshape(Dict(:, i*19+j-19), 48, 42);
    end
end
common=matrix2im(common, 'common.tif', 8);
condition=zeros(48*4, 42*8);
for i=1: 4
    for j=1: 8
        condition(i*48-47: i*48, j*42-41: j*42)=A_hat(:, (8*i+j-9)*42+1: (8*i+j-8)*42);
    end
end
condition=matrix2im(condition, 'condition.tif', 8);
X=zeros(48*32, 42*38);
%% ========================================================================
% reconstruct the image
for i=1: 32
    for j=1: 38
        X((i-1)*48+1: i*48, (j-1)*42+1: j*42)=A_hat(:, (i-1)*42+1: i*42)+C_hat(:, (j-1)*42+1: j*42);
    end
end
clear i j;
img=matrix2im(X, 'AR_E+C_1.25.tif', 8);
