% V8:   accerlate the speed for V1;
% V1:   the classification is based on the principle angle between two
% subspaces, i.e. C_i+{A_j} and X+{A_j}
% parameters:
% file_name:    the image name for test;
% C_hat:        the common part, where each column is for one subject;
% A_hat:        the low rank part, where each column is for one condition;
% G_hat:        not used in this version;
% option:       a structure contains many parameter;
% =========================================================================
function [idx, output]=TestSubspace8(img, C_hat, A_hat, G_hat, option)
%% ========================================================================
% Parameters
X=repmat(img(:), 1, size(A_hat, 2))+A_hat;
output.err=zeros(option.n_People, 1);
output.block=zeros(option.n_People, 25);
output.coef=zeros(option.n_People, size(A_hat, 2));
% =========================================================================
for i=1: option.n_People
    % we already return the cosine instead of angle
    % output.coef(i, :)=subspace_linear(repmat(C_hat(:, i), 1, size(A_hat, 2))+A_hat, X);
    output.block(i, :)=BlockError(repmat(C_hat(:, i), 1, size(A_hat, 2))+A_hat, X, G_hat);
end
%% ========================================================================
% do classification according to the reconstruction error
% output.err=sum(output.coef.^2, 2);
% [val, idx]=max(output.err);
tmp=max(output.block);
output.block=output.block./repmat(tmp, option.n_People, 1);
output.block=sum(output.block, 2);
[val, idx]=max(output.block);
end

% calculate the error in each block (1/2 overlapping), where mode decides 
% the error measurement we use:
% 1:    l1 norm;
% 2:    l2 norm;
function err=BlockError(X, Y, patch_mask)
err=zeros(1, 25);
nCol=size(X, 2);
for l=1: 25
    tmpTheta=subspace_linear(reshape(X(patch_mask{l}==1), [], nCol),...
        reshape(Y(patch_mask{l}==1), [], nCol));
    err(l)=sum(tmpTheta.^2);
end
end