% learn the weight for different features
%% ========================================================================
% Step 0.5: pre-processing the data
lambda=option.lambda/sqrt(55);
for i=1: 1300
    % set the data between 0 and 1
%     tmp=max(output(i).score);
%     output(i).score=output(i).score./repmat(tmp, size(output(i).score, 1), 1);
    output(i).err=output(i).score(:, 1)+lambda*output(i).score(:, 2);
    [val idx(i)]=min(output(i).err);
end
clear i tmp val;
% =========================================================================
%% ========================================================================
% Step 1:   generate the positive and negative data
% =========================================================================
% positive data is the score of true label
pdata=zeros(1300, 5);
for i=1: 1300
    pdata(i, :)=output(i).score(ceil(i/13), :);
end
% negative data is the score returned by idx or random
stream = RandStream('mrg32k3a');
ndata=zeros(1300, 5);
for i=1: 1300
    % use idx
    if idx(i)~=ceil(i/13)
        ndata(i, :)=output(i).score(idx(i), :);
    % randomly pick
    else
        while 1
            tmp=ceil(rand(stream, 1, 1)*100);
            if tmp~=idx(i)
                break;
            end
        end
        ndata(i, :)=output(i).score(tmp, :);
    end
end
clear i tmp;
%% ========================================================================
% Step 1.5 normalize
% =========================================================================
% up=max([pdata; ndata]);
% lo=min([pdata; ndata]);
% pdata=(pdata-repmat(lo, size(pdata, 1), 1))./(repmat(up, size(pdata, 1), 1)-repmat(lo, size(pdata, 1), 1));
% ndata=(ndata-repmat(lo, size(pdata, 1), 1))./(repmat(up, size(pdata, 1), 1)-repmat(lo, size(pdata, 1), 1));
%% ========================================================================
% Step 2:   train the svm
% =========================================================================
lbl=[ones(size(pdata, 1), 1); 0*ones(size(ndata, 1), 1)];
model = svmtrain(lbl, [pdata; ndata]);
w=model.alpha;
b=model.bias;
%% ========================================================================
% Step 3:   apply the classifiers
