% this script shows the usage of inexact_alm_rpca.m
% demo
% =========================================================================
clear;
% =========================================================================
% for video case
% file_name='C:\Documents and Settings\Qiang.MADDY\My Documents\Matlab\matrix completion\Hall.m1v';
% fstart=2801;
% fend=2950;
% X=movie2mat(file_name, fstart, fend);
% X=double(X);
% N=fend-fstart+1;
% =========================================================================
% for image case
% for AR
path='C:\Documents and Settings\Qiang.MADDY\My Documents\Matlab\SRC\AR\';
dirlist=dir([path 'M-001*.bmp']);
% for YaleB
% path='C:\Documents and Settings\Qiang.MADDY\My Documents\Matlab\SRC\YaleBFull\';
% dirlist=dir([path 'yaleB01_*.bmp']);
N=length(dirlist);
X=[];
for i=1: N
    img=imread([path dirlist(i).name]);
    img=imresize(img, [55, 40]);
    height=size(img, 1);
    width=size(img, 2);
    % color image?
    if size(img, 3)~=1
        X=[X reshape(0.2989*img(:, :, 1)+0.5870*img(:, :, 2)+0.1140*img(:, :, 3), [], 1)];
    else
        X=[X reshape(img, [], 1)];
    end
    % some preprocessing may be need here
end
X=double(X);
% =========================================================================
% set up parameters
% lambda=1/sqrt(size(X, 1));
% use a smaller weight for sparisity term
lambda=1/sqrt(size(X, 1));
tol=1e-7;
maxIter=1000;
% start program
% [A_hat, E_hat, iter]=inexact_alm_rpca(X, lambda, tol, maxIter);
[C_hat, A_hat, E_hat, output]=JointMC5(X, lambda, tol, maxIter, 1, 0, 1.25, 1.5);
% save result
% =========================================================================
% save into image
row=2;
column=13;
img=zeros(height*row, width*column);
for irow=1:row
    img((irow-1)*height+1: irow*height, :)=reshape(X(:, (irow-1)*column+1: irow*column), height, []);
end
matrix2im(img, ['AR' datestr(now, '-yy-mm-dd-HH-MM-SS-') 'X.tif'], 8);
if exist('C_hat', 'var')==1
    img=zeros(height*row, width*column);
    for irow=1:row
        img((irow-1)*height+1: irow*height, :)=reshape(C_hat(:, (irow-1)*column+1: irow*column), height, []);
    end
    matrix2im(img, ['AR' datestr(now, '-yy-mm-dd-HH-MM-SS-') 'C.tif'], 8);
end
img=zeros(height*row, width*column);
for irow=1:row
    img((irow-1)*height+1: irow*height, :)=reshape(E_hat(:, (irow-1)*column+1: irow*column), height, []);
end
matrix2im(img, ['AR'  datestr(now, '-yy-mm-dd-HH-MM-SS-') 'E.tif'], 8);
img=zeros(height*row, width*column);
for irow=1:row
    img((irow-1)*height+1: irow*height, :)=reshape(A_hat(:, (irow-1)*column+1: irow*column), height, []);
end
matrix2im(img, ['AR'  datestr(now, '-yy-mm-dd-HH-MM-SS-') 'A.tif'], 8);
clear irow img;
save([datestr(now, 'yy-mm-dd-HH-MM-SS-') 'AR.mat']);
% =========================================================================
% save to movie
% save([file_name(1:end-4) datestr(now, '-yy-mm-dd-HH-MM-SS-') sprintf('%04d-%04d.mat', fstart, fend)]);
% data={reshape(X, height, width, N) repmat(C_hat, [1, 1, N]) reshape(A_hat, height, width, N) reshape(abs(E_hat), height, width, N)};
% mat2movie(data, [file_name(1:end-4) datestr(now, '-yy-mm-dd-HH-MM-SS-') sprintf('%04d-%04d.avi', fstart, fend)]);
% =========================================================================
