% this function finds the correct mapping between the signal and low rank
% part. This version allows some training images are lost;
% considering efficiency, we use the dynamic programming method, i.e.
% identifying the optimal one by one
function [Phi, Psi]=findorder2(X, A_hat, C_hat, E_hat, omega, N, M, n, m)
Phi=zeros(N, M);
% Phi(1, :)=(1: M);
for i=1: N
    % from signal to low rank
    err=ones(M, M)*1e6;
    % calculating the order
    for j=1: M
        if omega(i, j)
            for l=1: M
                % l1 norm on E
                tmp=X((i-1)*m+1: i*m, (j-1)*n+1: j*n)-...
                    A_hat(:, (l-1)*n+1: l*n)-...
                    C_hat(:, (i-1)*n+1: i*n);
                err(j, l)=norm(tmp(:), 1);
            end
        end
    end
    % using dynamic to find the optimal mapping
    for t=1:  M
        [val, idx]=min(err(:)); %#ok<ASGLU>
        % convert to 2d coordinate
        pos_x=ceil(idx/M);
        pos_y=idx-(pos_x-1)*M;
        Phi(i, pos_y)=pos_x;
        % remove the column correpsonds to pos_x and pos_y
        err(pos_y, :)=inf;
        err(:, pos_x)=inf;
    end
end
Psi=zeros(N, M);
for i=1: N
    for j=1: M
        Psi(i, Phi(i, j))=j;
    end
end