% this script write the mat file into movie
% =========================================================================
function mat2movie(X, file_name)
% detect the file name
if file_name(end-3: end)~='.avi'
    file_name=[file_name '.avi'];
end
% create an avi object
aviobj = avifile(file_name, 'fps', 25);
% normalize the matrix
for i=1: length(X)
    tmp=X{i};
    up=max(tmp(:));
    lo=min(tmp(:));
    X{i}=(tmp-lo)*255/(up-lo);
end
% write the frame
for i=1: size(X{1}, 3)
    % i th frame
    img=[X{1}(:, :, i) X{2}(:, :, i); X{3}(:, :, i) X{4}(:, :, i)];
    img=repmat(img, [1, 1, 3]);
    aviobj = addframe(aviobj,uint8(img));
end
aviobj = close(aviobj);