% this function read in the moive and save into matlab file
% file_name:    the video file name;
% start:        the start frame number;
% end:          the end frame number;
% X will be a matrix in [m n*N], where N is number of frames
% =========================================================================
function X=movie2mat(file_name, fstart, fend)
% =========================================================================
% definition the window size
top=1;
bottom=128;
left=1;
right=160;
% =========================================================================
% read in to the moive
movie=mmreader(file_name);
% read the frames
frames=read(movie, [fstart fend]);
% extract the window
frames=frames(top:bottom, left: right, :, :);
% convert in to gray
if movie.VideoFormat=='RGB24'
    frames=frames(:, :, 1, :)*0.2989+frames(:, :, 2, :)*0.5870+frames(:, :, 3, :)*0.1140;
end
% convert the dimension
X=reshape(frames, (bottom-top+1), []);