% this script try to learn naive bayes classifiers. The features is the
% rank (by minimization) of |A|* and |E|1. The decision to be made is the
% joint rank.
clear all;
%% ========================================================================
% Part 1, extract the feature
load('AR-result.mat', 'output');
ra=zeros(1, 1300);
re=zeros(1, 1300);
pfa=zeros(1, 1300);
pfe=zeros(1, 1300);
nfa=[];
nfe=[];
lbl=ceil([1: 1300]/13);
for i=1: 1300
    output(i).score(:, 1)=output(i).score(:, 1)/sum(output(i).score(:, 1));
    output(i).score(:, 2)=output(i).score(:, 2)/sum(output(i).score(:, 2));
    % |A|*
    [~, idx]=min(output(i).score(:, 1));
    if idx==lbl(i)
        ra(i)=1;
    else
        ra(i)=0;
    end
    pfa(i)=output(i).score(lbl(i), 1)/sum(output(i).score(:, 1));
    nfa=[nfa; output(i).score(setdiff(1: 100, lbl(i)), 1)];
    % |E|1
    [~, idx]=min(output(i).score(:, 2));
    if idx==lbl(i)
        re(i)=1;
    else
        re(i)=0;
    end
    pfa(i)=output(i).score(lbl(i), 2);
    nfa=[nfa; output(i).score(setdiff(1: 100, lbl(i)), 2)];
end
%% ========================================================================
% Part 2, learn the conditional prob. (laplacian)
pra11=(length(find(ra==1))+1)/(1300+2);
pra01=(length(find(ra==0))+1)/(1300+2);
pra00=pra11;
pra10=pra01;
pre11=(length(find(re==1))+1)/(1300+2);
pre01=(length(find(re==0))+1)/(1300+2);
pre00=pre11;
pre10=pre01;
%% ========================================================================
% Part 3, learn the prob density for continous function (2 GMM)
[mu1, sigma1, prob1, ~]=LearnGMM(pfa);
[mu2, sigma2, prob2, ~]=LearnGMM(pfe);
[mu3, sigma3, prob3, ~]=LearnGMM(pfa);
[mu4, sigma4, prob4, ~]=LearnGMM(pfe);
%% ========================================================================
% Part 4, testing
clear output;
load('AR-10-07-23-23-09-14-result.mat', 'output');
idx=zeros(1, 1300);
for i=1: 1300
    output(i).score(:, 1)=output(i).score(:, 1)/sum(output(i).score(:, 1));
    output(i).score(:, 2)=output(i).score(:, 2)/sum(output(i).score(:, 2));
    % |A|*
    [~, idx1]=min(output(i).score(:, 1));
    fa=output(i).score(:, 1);
    [~, idx2]=min(output(i).score(:, 2));
    fe=output(i).score(:, 2);
    % go through all people
    p=zeros(1, 100);
    for j=1: 100
        if idx1==j
            pra1=pra11;
            pra0=pra10;
        else
            pra1=pra01;
            pra0=pra00;
        end
        if idx2==j
            pre1=pre11;
            pre0=pre10;
        else
            pre1=pre01;
            pre0=pre00;
        end
        p(j)=(pra1*pre1*ProbGMM(fa(j), mu1, sigma1, prob1)*ProbGMM(fe(j), mu2, sigma2, prob2))/(pre0*pra0*ProbGMM(fa(j), mu3, sigma3, prob3)*ProbGMM(fe(j), mu4, sigma4, prob4));
    end
    [~, idx(i)]=max(p);
end